package com.perforce;

public interface Constants {
	String BASE_PROPERTY_PREFIX = "com.perforce.admin.";
	
	// CONFIGURATION FILE INFO
	String RECONFIGURE_CONTEXT_ATTRIBUTE = "application.reconfigure";
	String CONFIGURATION_FILE_SYSTEM_PROPERTY = "admin.config";
	String CONFIGURATION_FILE_DEFAULT = "config.properties";
	
	// CONFIGURATION PROPERTIES
	String P4_PATH = "com.perforce.admin.P4Path";
	String PROTOCOL = "com.perforce.admin.serverProtocol";
	String HOSTNAME = "com.perforce.admin.serverHost";
	String PORTNUM = "com.perforce.admin.serverPort";
	String ADMINUSER = "com.perforce.admin.superUser";
	String ADMINPASS = "com.perforce.admin.superPassword";
	
	// APPLICATION SETTINGS (Stored as properties on the server)
	String PERFORCE_PASSWORDS = "com.perforce.admin.passwordsInPerforce";
	String UNIQUE_EMAILS = "com.perforce.admin.uniqueUserEmails";
	String REQUIRE_ACCOUNT_APPROVAL = "com.perforce.admin.accountApprovalRequired";
	String ACCOUNT_APPROVER_GROUP = "com.perforce.admin.accountApproverGroup";
	String HIDDEN_GROUPS = "com.perforce.admin.hiddenGroups";
	String AUTOSUBSCRIBE_GROUPS = "com.perforce.admin.autoSubscribeGroups";
	String DEFAULT_GROUP_OWNER = "com.perforce.admin.defaultGroupOwner";
	String USER_UPDATABLE_FIELDS = "com.perforce.admin.userCanUpdate";
	String FREE_USERS = "com.perforce.admin.minFreeUsers";
	String MAIL_HOST = "com.perforce.admin.mailHost";
	String MAIL_PORT = "com.perforce.admin.mailPort";
	String MAIL_FROM = "com.perforce.admin.mailFrom";
	String MAIL_AUTH = "com.perforce.admin.mailAuth";
	String MAIL_AUTH_USER = "com.perforce.admin.mailUser";
	String MAIL_AUTH_PASS = "com.perforce.admin.mailPass";
	String MAIL_SSL = "com.perforce.admin.mailSSL";
	String[] APPLICATION_SETTINGS = {
			PERFORCE_PASSWORDS, 
			UNIQUE_EMAILS, 
			REQUIRE_ACCOUNT_APPROVAL, 
			ACCOUNT_APPROVER_GROUP, 
			HIDDEN_GROUPS, 
			AUTOSUBSCRIBE_GROUPS, 
			DEFAULT_GROUP_OWNER, 
			USER_UPDATABLE_FIELDS,
			FREE_USERS, 
			MAIL_HOST, 
			MAIL_PORT, 
			MAIL_FROM, 
			MAIL_AUTH, 
			MAIL_AUTH_USER, 
			MAIL_AUTH_PASS, 
			MAIL_SSL
			};
	
	// CONTEXT ATTRIBUTES
	String CONFIGURED = "app.configured";
	
	// SESSION ATTRIBUTES
	String TICKET_SESSIONKEY = "ticket";
	String P4HELPER_SESSIONKEY = "helper";
	
	// REQUEST NOTIFICATION PREFIXES
	String ACCOUNT_REQUEST_PREFIX = "account.create.request.";
	String PASSWORD_REQUEST_PREFIX = "password.reset.request.";
	String GROUP_REQUEST_PREFIX = "group.membership.request.";
	String NOTIFICATION_PREFIX = "notification.";
	
}
